{SECTION ..PbDATA }
UNIT PbDATA;

INTERFACE


{
Description:  Global data for all programs

Author      : Howard Richoux
Date        : 2/18/94
Last revised: 8/11/92 Added pColorSet2
              10/16/94 replaced variables by constants, eliminating the init code
Application : IBM PC and compatibles, Turbo Pascal 7.0
Status      : Placed in the Public Domain by HNR Software 1/94
Published in: none
}

{SECTION ..PbPARMS_DATA }
{
These variables are supported by PbPARMS  .CFG file loading

Note: In future, could replace string vars by STR_objects and reduce footprint.

StandardpVarsInit - sets a group of standard variables, free decoding:
    Internal   External(CFG)    Possible Use                   Default
    --------   --------         ---------------------------    -------
    pFirst     FIRST=<nnn>      First record number to keep    0
    pLast      LAST=<nnn>       Last record number to keep     32700
    pCount     COUNT=<nnn>      Number of records to keep      32700
    pRecs      RECS=<nnn>       Number of records to keep      32700
    pSkip      SKIP=<nnn>       Number of records to skip      0
    pSize      SIZE=<nnn>       Record size                    16
    pDelay     DELAY=<nnn>      millisecond delay              100

    pDataPath  DATAPATH=xx..x   Data directory                 ''
    pOutFile                    CON LPT1, ...                  'CON'

    pDebug     DEBUG=ON         Turn On/Off debugging          false

    pColorScheme                for WINDOW_objects             0  b/w
    pSystemID                   TAG to identify system         ''
    pPrinterID                  TAG to identify printer type   ''
    pEditor                     EXE file for text editor       'c:\dos\edit'
    pCompiler                   EXE file for Compiler          'c:\bp\bin\tpc'
    pLocFile                    tags and directories           'c:\location.loc'
    pProgID    (*miscstuf*)     ID & version # of program      ''
    pCurrFName                  file being operated on         ''
}

const pSystemID       : string[12] = 'HNR';
const pPrinterID      : string[12] = 'LJ4';
const pProgID         : string[24] = '<pProgID>';
const pPubDomain      : boolean = true;
const pPubDomainMsg   : string[36] = '  Public Domain by HNR Software 1994';
const pCopyrightMsg   : string[32] = '  Copyright by HNR Software 1994';
const pServerFlag     : boolean = false;
const pDebug          : boolean = false;
const pSkip           : integer = 0;
const pFirst          : integer = 0;
const pLast           : integer = 32700;
const pRecs           : integer = 32700;
const pCount          : integer = 32700;
const pDelay          : integer = 100;
const pSize           : integer = 16;
const pColorSet       : integer = -1;    {ignore}
const pColorSet2      : integer = -1;    {ignore}
const pDataPath       : string[30] = '';
const pCurrFName      : string[50] = '??';
const pOutFile        : string[40] = 'CON';
const pEditor         : string[30] = 'c:\dos\edit.exe';
const pCompiler       : string[30] = 'c:\bp\bin\tpc.exe';
const pLocFile        : string[50] = 'c:\location.loc';

{section .ZIMPLEMENTATION }
IMPLEMENTATION

end.
